///////////////////////////////////////////////////////////////////////////
// Copyright (c) Panos Kougiouris 1997
///////////////////////////////////////////////////////////////////////////

#ifndef __CKFBASE_H_
#define __CKFBASE_H_

#ifdef __cplusplus
#include <assert.h>

#ifdef WIN32
/* We use the SignalAndWaitForObject() */
#define _WIN32_WINNT 0x0400
#include <strstrea.h>
#else
#include <strstream.h>
#endif

extern "C" {
#endif

typedef enum { CKFFalse = 0, CKFTrue = 1 } CKFBool;

#ifdef WIN32
#include <Windows.h>

#define DllExport   __declspec( dllexport )
#define DllImport   __declspec( dllimport )

/* CKFDLL is defined only when we build the library itself */
#ifdef CKFDLL
#define CKFEXPORT DllExport
#else
#define CKFEXPORT DllImport
#endif

#else
#define CKFEXPORT
#define CKFEXPORT
#endif

#ifdef __cplusplus
}
#endif

#endif	/* __CKFBASE_H_ */
